<?php

/**
 * Gadget Web Development Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: Tagrules.php,v 1.1 2005/04/04 11:50:57 mike Exp $
 */

/**
 * Requires XML_Parser
 */
class_exists('XML_Parser') or require_once 'XML/Parser.php';

/** 
 * Gadget_Formatter_Tagrules
 *
 * @package     Gadget
 * @since       1.0
 */
class Gadget_Formatter_Tagrules extends XML_Parser
{
    /**
     * Case Folding
     * 
     * @var bool
     */
    var $folding = true;
    
    /**
     * Tag Rules
     * 
     * @var array
     */
    var $rules = array();
    
    /**
     * Parse Rules
     * 
     * @access  public
     * @return  array
     * @param   string  $file
     */
    function parseRules($file)
    {
        if (!is_file($file)) {
            return array();
        }
        
        if (PEAR::isError($this->setInputFile($file))) {
            return array();
        }
        if (PEAR::isError($this->parse())) {
            return array();
        }
        
        return $this->rules;
    }
    
    /**
     * @ignore
     */
    function startHandler($xp, $e, $a)
    {
        if ($e === 'RULE') {
            $this->rules[$a['SEARCH']] = $a['REPLACE'];
        }
    }
}

?>
