<?php

/**
 * Gadget Web Development Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @subpackage  Gadget_Provider
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: Provider.php,v 1.1 2005/04/04 11:50:57 mike Exp $
 */

/**
 * Requires Gadget_Plugin
 */
class_exists('Gadget_Plugin') or require_once 'Gadget/Plugin.php';

/**
 * Gadget_Provider configuration
 * @ignore
 */
$GLOBALS['_Gadget'][GADGET_PROVIDER]['Config'] = array();

/**
 * Gadget_Provider registry
 * @ignore
 */
$GLOBALS['_Gadget'][GADGET_PROVIDER]['Registry'] = array(
    PROVIDER_CONFIGURATION  => array(
        'default'   => array('Gadget_Provider_Configuration', null),
        'userdef'   => array(),
    ),
    PROVIDER_PREFERENCES    => array(
        'default'   => array('Gadget_Provider_Preferences', null),
        'userdef'   => array(),
    ),
    PROVIDER_CURRENTUSER    => array(
        'default'   => array('Gadget_Provider_Currentuser', null),
        'userdef'   => array(),
    ),
    PROVIDER_AUTOLOGIN      => array(
        'default'   => array('Gadget_Provider_Autologin', null),
        'userdef'   => array(),
    ),
    PROVIDER_RIGHTS         => array(
        'default'   => array('Gadget_Provider_Rights', null),
        'userdef'   => array(),
    ),
    PROVIDER_CACHE          => array(
        'default'   => array('Gadget_Provider_Cache', null),
        'userdef'   => array(),
    ),
);

/**
 * Gadget_Provider
 *
 * Gadget's provider base class.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Provider
 * @since       1.0
 */
class Gadget_Provider extends Gadget_Plugin
{
    /**
     * Plugin Type
     * 
     * @var string
     */
    var $plugin = GADGET_PROVIDER;
    
    /**
     * Provider
     * 
     * @var string
     */
    var $provider;
    
    /**
     * Singleton
     * 
     * @static
     * @access  public
     * @return  object
     * @param   string
     */
    function &singleton($provider)
    {
        return parent::singleton(GADGET_PROVIDER, $provider);
    }
    
    /**
     * Configure a Provider
     * 
     * @static
     * @access  public
     * @return  void
     * @param   string
     * @param   mixed
     */
    function configure($provider, $params)
    {
        return parent::configure(GADGET_PROVIDER, $provider, $params);
    }
    
    /**
     * Register Provider
     * 
     * @access  public
     * @return  void
     * @param   string
     * @param   string
     * @param   string
     */
    function register($provider, $class, $file = null)
    {
        return parent::register(GADGET_PROVIDER, $provider, $class, $file);
    }
    
    /**
     * Lookup
     * 
     * @access  public
     * @return  array
     * @param   string
     */
    function lookup($provider)
    {
        return parent::lookup(GADGET_PROVIDER, $provider);
    }
}

?>
