<?php

/**
 * Gadget Web Development Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @subpackage  Gadget_Provider
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: Autologin.php,v 1.1 2005/04/04 11:50:57 mike Exp $
 */

/**
 * Requires Gadget_Provider
 */
class_exists('Gadget_Provider') or require_once 'Gadget/Provider.php';

/**
 * Gadget_Provider_Autologin
 *
 * Gadget's default autologin provider.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Provider
 * @since       1.0
 */
class Gadget_Provider_Autologin extends Gadget_Provider
{
    var $provider = PROVIDER_AUTOLOGIN;
    
    /**
     * Get
     * 
     * @access  public
     * @return  mixed
     */
    function get()
    {
        return Gadget::getCookie('autologin', true);
    }
    
    /**
     * Set
     * 
     * @access  public
     * @return  void
     * @param   bool
     */
    function set($enable)
    {
        if ($enable) {
            $user = &Gadget::currentUser(true);
            Gadget::setCookie('autologin', 
                array(
                    'alias'     => $user->alias, 
                    'password'  => md5($user->password),
                )
            );
        } else {
            Gadget::unsetCookie('autologin');
        }
    }
    
}

?>
