<?php

/**
 * Gadget Web Development Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: Autologin.php,v 1.1 2005/04/04 11:50:58 mike Exp $
 */

/**
 * Requires Gadget_Service_Auth
 */
class_exists('Gadget_Service_Auth') or require_once 'Gadget/Service/Auth.php';

/**
 * Gadget_Service_Autologin
 *
 * Gadget's default autologin service.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @since       1.0
 */
class Gadget_Service_Autologin extends Gadget_Service_Auth
{
    var $service = SERVICE_AUTOLOGIN;
    
    /**
     * Execute
     * 
     * @access  protected
     * @return  bool
     * @param   string  $alias
     * @param   string  $password
     */
    function execute($alias, $password)
    {
        return parent::execute($alias, $password, 'in');
    }
    
    /**
     * On Failure
     * 
     * @access  protected
     * @return  bool false
     */
    function onFailure()
    {
        Gadget::callProviderSet(PROVIDER_AUTOLOGIN, false);
        return Gadget_Service::onFailure();
    }
    
}

?>
