<?php

/**
 * Gadget Webdevelopment Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: Errordisplay.php,v 1.1 2005/04/04 11:50:58 mike Exp $
 */

/**
 * Requires Gadget_Service
 */
class_exists('Gadget_Service') or require_once 'Gadget/Service.php';

/** 
 * Gadget_Service_Errordisplay
 *
 * Gadget's default Error Display Service.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @since       1.0
 */
class Gadget_Service_Errordisplay extends Gadget_Service
{
    var $service = SERVICE_ERRORDISPLAY;
    
    /**
     * Execute
     * 
     * @access  protected
     * @return  bool true
     * @param   object PEAR_Error $e
     */
    function execute($e)
    {
        Gadget::newWidget(
            'DivContainer',
            array(
                'class'     => 'error',
                'style'     => 'background: #ff0; border: solid #f00;',
                'content'   => sprintf('<p><strong>%s:</strong></p><p>%s<br />%s</p>',
                    _('Fehler'), $e->getMessage(), $e->getUserInfo())
            )
        );
        return true;
    }
    
}

?>
