<?php

/**
 * Gadget Webdevelopment Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: var.php,v 1.1 2005/04/04 11:50:58 mike Exp $
 */

/**
 * Requires Gadget_Template_Action
 */
class_exists('Gadget_Template_Action') or require_once 'Gadget/Template/Action.php';

/** 
 * Gadget_Template_Action_var
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.0
 */
class Gadget_Template_Action_var extends Gadget_Template_Action
{
    /**
     * Name
     * 
     * @var string
     */
    var $name = 'var';
    
    /**
     * On After Construct
     * 
     * @access  protected
     * @return  void
     */
    function onAfterConstruct()
    {
        $this->composedPattern = 
            $this->pcreDelimiter        .
            $this->quotedChars['start'] .
            '('                         .
            $this->quotedChars['var']   .
            $this->pcreRecursion        .
            ')'                         .
            $this->quotedChars['end']   .
            $this->pcreDelimiter
        ;
    }
    
    /**
     * Perform
     * 
     * @access  public
     * @return  string
     * @param   array   $args
     */
    function perform($args)
    {
        if ($this->phpize) {
            return '<?php echo '. $this->parseArg($args[1]) .'; ?>';
        }
        return '\'.'. $this->parseArg($args[1]) .'.\'';
    }
}

?>
