<?php

/**
 * Gadget Web Development Kit
 * 
 * @GADGET_HEADER@
 * 
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.1 $
 * 
 * @copyright   2004 Michael Wallner
 * @license     http://www.gnu.org/copyleft/gpl.txt GNU Public License
 * 
 * @cvs         $Id: Breadcrumbs.php,v 1.1 2005/04/04 12:15:55 mike Exp $
 */

/**
 * Requires Gadget_Formatter
 */
class_exists('Gadget_Widget') or require_once 'Gadget/Widget.php';

/**
 * Breadcrumbs
 *
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @since       1.0
 */
class Breadcrumbs extends Gadget_Widget
{
    var $template = 'Breadcrumbs.html';
    var $aggregateFormatter = true;
    
    var $header;
    
    var $crumbs = array();
    var $hrefBase = '/';
    
    function main()
    {
        $this->header = &Gadget::header();
    }
    
    /**
     * Add Crumb
     *
     * @access  public
     * @return  void
     * @param   string  $href
     * @param   string  $title
     */
    function addCrumb($href, $title)
    {
        // compose sane href
        $href = preg_replace('/\/+/', '/', $this->hrefBase .'/'. $href);
        
        // add "up" link
        if (0 <= $idx = count($this->crumbs) - 1) {
            $this->header->addLink('up', 
                $this->crumbs[$idx]->href, 
                $this->crumbs[$idx]->title
            );
        }
        
        // add crumb
        $this->crumbs[] = (object) array('href' => $href, 'title' => $title);
    }
    
    /**
     * Start
     * 
     * @access  public
     * @return  void
     * @param   string  $hrefBase
     */
    function start($hrefBase = '/')
    {
        $this->hrefBase = $hrefBase;
    }
    
    /**
     * Finish
     *
     * @access  public
     * @return  void
     */
    function finish()
    {
        $this->hrefBase = '/';
    }
}

?>
